Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans
Class ClassObject

    java.lang.Object
      oracle.ifs.beans.LibraryObject
          oracle.ifs.beans.TieLibraryObject
              oracle.ifs.beans.SchemaObject
                  oracle.ifs.beans.TieSchemaObject
                      oracle.ifs.beans.ClassObject

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, SchemaObjectInterface, Traceable

    public class ClassObject

extends TieSchemaObject

A ClassObject represents a class whose instances are persistently stored and managed by the iFS server.

When installed, iFS creates a number of ClassObjects. Some of these are used internally; others are for commonly-encountered data types in content management applications. A content management application can use these provided ClassObjects, or create its own by subclassing them.

Each ClassObject may define one or more Attributes for its data. In addition to these, a ClassObject inherits its superclass's Attributes.

Any time a ClassObject is created, altered, or removed, the in-progress Transaction is implicitly committed.

See Also:
  `ClassObjectDefinition`
(Published)

Field Summary
`static java.lang.String` | `ABSTRACT_ATTRIBUTE` An indicator of whether this ClassObject is abstract.
`static java.lang.String` | `BEANCLASSPATH_ATTRIBUTE` The fully-qualified classname of the Beans Java class used to represent instances of this ClassObject in the repository SDK.
`static java.lang.String` | `CLASS_NAME` The class name for this class.
`static java.lang.String` | `CLASSACL_ATTRIBUTE` The ClassAccessControlList that determines which users and/or groups can create instances of this ClassObject.
`static java.lang.String` | `CLASSPOLICYLIST_ATTRIBUTE` The set of Policies implicitly applied to all instances of a ClassObject.
`static java.lang.String` | `DATABASEOBJECTNAME_ATTRIBUTE` The base name for database objects used to store data for instances of this ClassObject.
`static java.lang.String` | `DESCRIPTION_ATTRIBUTE` A textual description of this ClassObject.
`static java.lang.String` | `FINAL_ATTRIBUTE` An indicator of whether this ClassObject is final.
`protected ClassObject` | `m_Superclass` The Superclass of this CLASSOBJECT.
`protected boolean` | `m_SuperclassResolved` Whether the superclass has been resolved.
`static java.lang.String` | `PARTITIONED_ATTRIBUTE` An indicator of whether the database table that stores data for instances of this ClassObject is partitioned.
`static java.lang.String` | `SELECTORCLASSPATH_ATTRIBUTE` The fully-qualified classname of the Beans Java class used to represent instances of this ClassObject in the repository SDK.
`static java.lang.String` | `SERVERCLASSPATH_ATTRIBUTE` The fully-qualified classname of the Server Java class used to represent instances of this ClassObject in the repository service.
`static java.lang.String` | `SUPERCLASS_ATTRIBUTE` The ClassObject that is the superclass of this ClassObject.
`static java.lang.String` | `UNIQUENAME_ATTRIBUTE` A system-set attribute used to ensure each ClassObject has a unique Name.

Fields inherited from class oracle.ifs.beans.SchemaObject
`ACTIVE_ATTRIBUTE, NAME_ATTRIBUTE, POLICYBUNDLE_ATTRIBUTE, POLICYLISTS_ATTRIBUTE, PROPERTYBUNDLE_ATTRIBUTE`

Fields inherited from class oracle.ifs.beans.LibraryObject
`DOMAIN_UNIQUENAME_DEFAULT_DELIMITER, m_ClassId, m_Id, m_Session`

Constructor Summary
`protected` | `ClassObject(LibrarySession session, java.lang.Long id, java.lang.Long classId, S_ClassObjectData data)` Internal use only: Constructs a ClassObject.
`protected` | `ClassObject(LibrarySession session, java.lang.Long id, java.lang.Long classId, S_LibraryObjectData data)` Constructs a ClassObject.

Method Summary
`Attribute` | `addAttribute(AttributeDefinition def)` Adds an Attribute to this ClassObject.
`protected static ClassObject` | `constructClassObject(LibrarySession sess, S_LibraryObjectData data)` Internal use only: Constructs a ClassObject for the specified data.
`protected static java.util.Vector` | `constructClassObjectVector(LibrarySession sess, java.util.Vector vector)` Internal use only: Converts a vector of S_LibraryObjectDatas to a vector of ClassObjects.
`static ClassObject[]` | `findAll(LibrarySession session)` Returns the set of defined ClassObjects.
`static ClassObject` | `findByName(LibrarySession session, java.lang.String name)` Returns the a ClassObject matching the specified name.
`Attribute` | `getAttributeFromLabel(java.lang.String label)` returns the Attribute, based on the specified Attribute Label.
`java.lang.String` | `getBeanClasspath()` Gets the fully-qualified name of the Java class instantiated to represent instances of this ClassObject within a document management application.
`java.lang.reflect.Constructor` | `getBeansConstructor()` Internal use only: Gets the four-argument constructor for the Java class returned by `getBeansClasspath`.
`ClassAccessControlList` | `getClassAcl()` Gets the ClassAccessControlList of this ClassObject.
`static ClassObject` | `getClassObjectFromLabel(LibrarySession sess, java.lang.String label)` returns a ClassObject, based on a specified Label.
`PolicyList` | `getClassPolicyList()` Gets the ClassPolicyList of this object.
`java.lang.String` | `getDatabaseObjectName()` Returns the Database Object Name.
`java.lang.String` | `getDescription()` Returns the description of a Class Object.
`ClassObject[]` | `getDirectSubclasses()` Gets the direct subclasses of this ClassObject.
`ClassObject` | `getDirectSubclasses(int index)` Gets the specified direct subclass of this ClassObject.
`int` | `getEffectiveClassAttributeIndex(java.lang.String attributeName)` Gets the index of the specified effective Attribute of this ClassObject.
`Attribute[]` | `getEffectiveClassAttributes()` Gets the effective Attributes of this ClassObject.
`Attribute` | `getEffectiveClassAttributes(int index)` Gets the specified effective Attribute of this ClassObject.
`Attribute` | `getEffectiveClassAttributes(java.lang.String attributeName)` Gets the specified effective Attribute of this ClassObject.
`java.util.Vector` | `getEffectiveClassPolicyListElements(java.lang.String operation)` Gets the set of policies, as PolicyListElements, implicitly applied to all instances of this ClassObject for the specified operation.
`int` | `getExtendedClassAttributeIndex(java.lang.String attributeName)` Gets the index of the specified extended Attribute of this ClassObject.
`Attribute[]` | `getExtendedClassAttributes()` Gets the extended Attributes of this ClassObject.
`Attribute[]` | `getExtendedClassAttributes(ClassObject superclass)` Gets an array of the Attributes that this ClassObject has and that the specified superclass does not have.
`Attribute` | `getExtendedClassAttributes(int index)` Gets the specified extended Attribute of this ClassObject.
`Attribute` | `getExtendedClassAttributes(java.lang.String attributeName)` Gets the specified extended Attribute of this ClassObject.
`AttributeValue` | `getInheritedPropertyValue(java.lang.String name)` gets named property, if any, by searching in the target ClassObject's PropertyBundle, or in one of its superclasses PropertyBundle.
`java.lang.String` | `getLabel()` returns the Label for this Attribute, based on the Attribute's name and class.
`static LibraryObjectLookupCache` | `getLibraryObjectLookupCache(LibrarySessionInterface session)` Returns the LibraryObjectLookupCache used by find ClassObject instances by name.
`java.lang.String` | `getSelectorClasspath()` Returns the SelectorClassPath Attribute of the Library Object.
`java.lang.String` | `getServerClasspath()` Returns the ServerClassPath Attribute of the Library Object.
`ClassObject[]` | `getSubclasses()` Gets the subclasses of this ClassObject.
`ClassObject` | `getSubclasses(int index)` Gets the specified subclass of this ClassObject.
`ClassObject` | `getSuperclass()` Gets the superclass of this ClassObject.
`boolean` | `isAbstract()` Determines if this is an abstract object.
`boolean` | `isAttribute(java.lang.String attrName)` Gets whether this ClassObject has an Attribute with the specified name.
`boolean` | `isDirectSubclassOf(ClassObject classObject)` Gets whether this ClassObject is a direct subclass of the specified ClassObject.
`boolean` | `isFinal()` Determines if this is object cannot be sub-classed.
`boolean` | `isPartitioned()` Determines if this is a partitioned object.
`boolean` | `isSubclassOf(ClassObject classObject)` Gets whether this ClassObject is a subclass of the specified ClassObject.
`boolean` | `isVersionable()` Gets whether instances of this ClassObject are versionable.
`void` | `putPolicy(Policy policy)` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`void` | `removeAllPolicies()` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`void` | `removeAttribute(Attribute attribute)` Removes an Attribute from this ClassObject.
`void` | `removeAttribute(Attribute attribute, AttributeDefinition def)` Removes an attribute from this ClassObject.
`void` | `removePolicy(Policy policy)` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`void` | `removePolicy(java.lang.String opname)` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`void` | `setBeanClasspath(java.lang.String javaClassName)` Sets the fully-qualified name of the Java class instantiated to represent instances of this ClassObject within a document management application.
`void` | `setClassAcl(ClassAccessControlList acl)` Sets the ClassAccessControlList of this ClassObject.
`void` | `setClassPolicyList(PolicyList policyList)` Sets the ClassPolicyList of this object.
`void` | `setDescription(java.lang.String description)` Sets the description of this ClassObject.
`void` | `setPolicyBundle(PolicyPropertyBundle bundle)` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`void` | `setSelectorClasspath(java.lang.String path)` Sets the Selector Class Path attribute.
`void` | `setServerClasspath(java.lang.String path)` Sets the Server Class Path attribute.
`protected static ClassObject` | `vectorClassObjectElement(java.util.Vector vector, int index)` Internal use only: Gets the specified element of a vector of ClassObjects.
`static ClassObject[]` | `vectorToClassObjectArray(java.util.Vector vector)` Internal use only: Converts a vector of ClassObjects to an a ClassObject array.

Methods inherited from class oracle.ifs.beans.SchemaObject
`addCategory, constructSchemaObject, constructSchemaObjectVector, free, getCategories, getCategories, getCategories, getCategories, getPolicyBundle, getPolicyLists, handleCreate, hasNameAttribute, isActive, postCreate, postUpdate, setActive, setPolicyLists`

Methods inherited from class oracle.ifs.beans.LibraryObject
`applyProperties, auditCreated, auditUpdated, checkRequiredAttributeSet, clearCopyContext, clearFreeContext, clearUpdateContext, constructIdArray, constructIdArray, constructLibraryObject, constructLibraryObjectVector, createDedicatedPropertyBundle, deriveDomainUniqueName, dispose, equals, free, get, getAttribute, getAttributeByUpperCaseName, getAttributes, getAttributesByUpperCaseNames, getAuditDomainContext, getAuditEventFolderContext, getClassId, getClassname, getClassName, getClassObject, getCommonName, getCopyContext, getCreateContext, getData, getDefinition, getEffectivePolicyListElements, getEventualAttributeByUpperCaseName, getFreeContext, getId, getName, getObjectReferenceAttribute, getOperationActionSpecificationContext, getPropertyBundle, getPropertyValue, getPublicObjectAttribute, getResourceString, getResourceString, getSchemaObjectAttribute, getSession, getSessionInterface, getSharedStateFactory, getStringIdentifier, getSystemObjectAttribute, getTraceLogger, getUpdateContext, handleAdminModeChange, handleEvent, handleFree, handleUpdate, hashCode, invokeOperation, invokeOperation, invokeServerMethod, isConnected, isCoreEventPostingEnabled, isInstanceOf, isTraced, isValidEventType, lockRows, lookupInstanceLabel, postEvent, postEvent, postFree, preCreate, preFree, prePostAuditEvent, preUpdate, putProperty, putProperty, removeAllProperties, removeProperty, renderAsRandomAccessContent, renderAsReader, renderAsStream, setAttribute, setAttribute, setAttributes, setAttributes, setCopyContext, setFreeContext, setId, setName, setPropertyBundle, setPropertyValue, setUpdateContext, toString, trace, trustHandleCreate, trustHandleCreateAsAdmin, trustHandleFree, trustHandleFreeAsAdmin, trustHandleUpdate, trustHandleUpdateAsAdmin, update, updateAndExposeDefinition, validatePropertyValues, vectorLibraryObjectElement, vectorToLibraryObjectArray, verifyAdministrationMode, verifyConnected, verifySystemUserAccess, verifyTargetObject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getAttributeByUpperCaseName, getClassId, getId, getSessionInterface`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Field Detail

### CLASS_NAME

    public static final java.lang.String CLASS_NAME

  Description copied from class: `ClassObject`
  The class name for this class. Useful for methods that take a class name argument.

  See Also:
    Constant Field Values
  (Published)

### SUPERCLASS_ATTRIBUTE

    public static final java.lang.String SUPERCLASS_ATTRIBUTE

  Description copied from class: `ClassObject`
  The ClassObject that is the superclass of this ClassObject.

  See Also:
    Constant Field Values
  (Published)

### DESCRIPTION_ATTRIBUTE

    public static final java.lang.String DESCRIPTION_ATTRIBUTE

  Description copied from class: `ClassObject`
  A textual description of this ClassObject.

  See Also:
    Constant Field Values
  (Published)

### SERVERCLASSPATH_ATTRIBUTE

    public static final java.lang.String SERVERCLASSPATH_ATTRIBUTE

  Description copied from class: `ClassObject`
  The fully-qualified classname of the Server Java class used to represent instances of this ClassObject in the repository service.

  See Also:
    Constant Field Values
  (Published)

### BEANCLASSPATH_ATTRIBUTE

    public static final java.lang.String BEANCLASSPATH_ATTRIBUTE

  Description copied from class: `ClassObject`
  The fully-qualified classname of the Beans Java class used to represent instances of this ClassObject in the repository SDK.

  See Also:
    Constant Field Values
  (Published)

### SELECTORCLASSPATH_ATTRIBUTE

    public static final java.lang.String SELECTORCLASSPATH_ATTRIBUTE

  Description copied from class: `ClassObject`
  The fully-qualified classname of the Beans Java class used to represent instances of this ClassObject in the repository SDK.

  See Also:
    Constant Field Values
  (Published)

### DATABASEOBJECTNAME_ATTRIBUTE

    public static final java.lang.String DATABASEOBJECTNAME_ATTRIBUTE

  Description copied from class: `ClassObject`
  The base name for database objects used to store data for instances of this ClassObject.

  See Also:
    Constant Field Values
  (Published)

### CLASSACL_ATTRIBUTE

    public static final java.lang.String CLASSACL_ATTRIBUTE

  Description copied from class: `ClassObject`
  The ClassAccessControlList that determines which users and/or groups can create instances of this ClassObject. If a ClassACL is not specified, then any user can create an instance of the ClassObject (unless it is an abstract class).

  See Also:
    Constant Field Values
  (Published)

### CLASSPOLICYLIST_ATTRIBUTE

    public static final java.lang.String CLASSPOLICYLIST_ATTRIBUTE

  Description copied from class: `ClassObject`
  The set of Policies implicitly applied to all instances of a ClassObject.

  See Also:
    Constant Field Values
  (Published)

### ABSTRACT_ATTRIBUTE

    public static final java.lang.String ABSTRACT_ATTRIBUTE

  Description copied from class: `ClassObject`
  An indicator of whether this ClassObject is abstract. Abstract ClassObjects cannot be instantiated.

  See Also:
    Constant Field Values
  (Published)

### FINAL_ATTRIBUTE

    public static final java.lang.String FINAL_ATTRIBUTE

  Description copied from class: `ClassObject`
  An indicator of whether this ClassObject is final. Final ClassObjects cannot be subclassed.

  See Also:
    Constant Field Values
  (Published)

### PARTITIONED_ATTRIBUTE

    public static final java.lang.String PARTITIONED_ATTRIBUTE

  Description copied from class: `ClassObject`
  An indicator of whether the database table that stores data for instances of this ClassObject is partitioned. Currently only PublicObject database tables are partitioned.

  See Also:
    Constant Field Values
  (Published)

### UNIQUENAME_ATTRIBUTE

    public static final java.lang.String UNIQUENAME_ATTRIBUTE

  Description copied from class: `ClassObject`
  A system-set attribute used to ensure each ClassObject has a unique Name.

  See Also:
    Constant Field Values
  (Published)

### m_Superclass

    protected ClassObject m_Superclass

  Description copied from class: `ClassObject`
  The Superclass of this CLASSOBJECT.

  (Unpublished)

### m_SuperclassResolved

    protected boolean m_SuperclassResolved

  Description copied from class: `ClassObject`
  Whether the superclass has been resolved.

  (Unpublished)

Constructor Detail

### ClassObject

    protected ClassObject(LibrarySession session,
                          java.lang.Long id,
                          java.lang.Long classId,
                          S_LibraryObjectData data)
                   throws IfsException

  Constructs a ClassObject.

  Parameters:
    `session` - the session
    `id` - the id
    `classId` - the class id
    `data` - the data
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### ClassObject

    protected ClassObject(LibrarySession session,
                          java.lang.Long id,
                          java.lang.Long classId,
                          S_ClassObjectData data)
                   throws IfsException

  Internal use only: Constructs a ClassObject.

  For internal use only. Do not use this method. To create a new ClassObject, use `LibrarySession.createSchemaObject`.

  Parameters:
    `session` - the session
    `id` - the id
    `classId` - the class id
    `data` - the data
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

Method Detail

### getLabel

    public java.lang.String getLabel()
                              throws IfsException

  Description copied from class: `ClassObject`
  returns the Label for this Attribute, based on the Attribute's name and class. This overrides the method defined in LibraryObject so that the AttributeLabel resource strings can be checked instead of the InstanceLabels that are checked in LibraryObject. If no AttributeLabel is defined, return the Attribute's name.

  Overrides:
    `getLabel` in class `LibraryObject`
  Returns:
    the label for this object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getClassObjectFromLabel

    public static ClassObject getClassObjectFromLabel(LibrarySession sess,
                                                      java.lang.String label)
                                               throws IfsException

  Description copied from class: `ClassObject`
  returns a ClassObject, based on a specified Label.

  Parameters:
    `sess` - The LibrarySession
    `label` - The Label
  Returns:
    the corresponding ClassObject.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAttributeFromLabel

    public Attribute getAttributeFromLabel(java.lang.String label)
                                    throws IfsException

  Description copied from class: `ClassObject`
  returns the Attribute, based on the specified Attribute Label.

  Parameters:
    `label` - the Attribute label
  Returns:
    the corresponding Attribute
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getBeanClasspath

    public java.lang.String getBeanClasspath()
                                      throws IfsException

  Description copied from class: `ClassObject`
  Gets the fully-qualified name of the Java class instantiated to represent instances of this ClassObject within a document management application.

  Returns:
    the classname
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setDescription

    public void setDescription(java.lang.String description)
                        throws IfsException

  Description copied from class: `ClassObject`
  Sets the description of this ClassObject.

  Parameters:
    `description` - the description
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setBeanClasspath

    public void setBeanClasspath(java.lang.String javaClassName)
                          throws IfsException

  Description copied from class: `ClassObject`
  Sets the fully-qualified name of the Java class instantiated to represent instances of this ClassObject within a document management application. The service should be restarted after calling this method.

  Parameters:
    `javaClassName` - the classname
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setClassPolicyList

    public void setClassPolicyList(PolicyList policyList)
                            throws IfsException

  Description copied from class: `ClassObject`
  Sets the ClassPolicyList of this object.

  Parameters:
    `policyList` - the ClassPolicyList
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getClassPolicyList

    public PolicyList getClassPolicyList()
                                  throws IfsException

  Description copied from class: `ClassObject`
  Gets the ClassPolicyList of this object.

  Returns:
    the ClassPolicyList
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getClassAcl

    public ClassAccessControlList getClassAcl()
                                       throws IfsException

  Description copied from class: `ClassObject`
  Gets the ClassAccessControlList of this ClassObject.

  Returns:
    the ClassAccessControlList
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setClassAcl

    public void setClassAcl(ClassAccessControlList acl)
                     throws IfsException

  Description copied from class: `ClassObject`
  Sets the ClassAccessControlList of this ClassObject.

  Parameters:
    `acl` - the ClassAccessControlList
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getEffectiveClassPolicyListElements

    public java.util.Vector getEffectiveClassPolicyListElements(java.lang.String operation)
                                                         throws IfsException

  Description copied from class: `ClassObject`
  Gets the set of policies, as PolicyListElements, implicitly applied to all instances of this ClassObject for the specified operation.

  The PolicyListElements are returned in SORTSEQUENCE order. If more than one PolicyListElement has a particular SORTSEQUENCE value, a PolicyListElement introduced by a classobject precedes the PolicyListElements introduced by the superclasses of that classobject.

  Parameters:
    `operation` - the operation of interest, or null for all operations
  Returns:
    a Vector of PolicyListElement objects
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setPolicyBundle

    public void setPolicyBundle(PolicyPropertyBundle bundle)
                         throws IfsException

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `ClassObject`
  Sets the policy bundle PropertyBundle of this ClassObject.

  Overrides:
    `setPolicyBundle` in class `SchemaObject`
  Parameters:
    `bundle` - the policy bundle
  Throws:
    `IfsException` - if the operation fails
  (Published)

### putPolicy

    public void putPolicy(Policy policy)
                   throws IfsException

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `ClassObject`
  Adds a Policy to the policy bundle PropertyBundle of this ClassObject.

  If this ClassObject doesn't have a policy bundle, this method will create one with a Published ACL and default name and description.

  Overrides:
    `putPolicy` in class `SchemaObject`
  Parameters:
    `policy` - the Policy to add
  Throws:
    `IfsException` - if the operation fails
  (Published)

### removePolicy

    public void removePolicy(java.lang.String opname)
                      throws IfsException

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `ClassObject`
  Removes a Policy from this ClassObject's policy bundle PropertyBundle.

  Overrides:
    `removePolicy` in class `SchemaObject`
  Parameters:
    `opname` - the operation name of the Policy to remove
  Throws:
    `IfsException` - if the operation fails
  (Published)

### removePolicy

    public void removePolicy(Policy policy)
                      throws IfsException

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `ClassObject`
  Removes a Policy from this ClassObject's policy bundle PropertyBundle.

  This method does not cause a "dedicated" PropertyBundle to be created.

  Overrides:
    `removePolicy` in class `SchemaObject`
  Parameters:
    `policy` - the Policy to remove
  Throws:
    `IfsException` - if the operation fails
  (Published)

### removeAllPolicies

    public void removeAllPolicies()
                           throws IfsException

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `ClassObject`
  Removes all Policy objects from this ClassObject's policy bundle PropertyBundle, leaving an empty PropertyBundle.

  Overrides:
    `removeAllPolicies` in class `SchemaObject`
  Throws:
    `IfsException` - if the operation fails
  (Published)

### addAttribute

    public Attribute addAttribute(AttributeDefinition def)
                           throws IfsException

  Description copied from class: `ClassObject`
  Adds an Attribute to this ClassObject.

  Parameters:
    `def` - the AttributeDefinition of the new Attribute
  Returns:
    the new Attribute
  Throws:
    `IfsException` - (IFS-30820) if the operation fails
  (Published)

### removeAttribute

    public void removeAttribute(Attribute attribute)
                         throws IfsException

  Description copied from class: `ClassObject`
  Removes an Attribute from this ClassObject.

  Parameters:
    `attribute` - the Attribute to remove
  Throws:
    `IfsException` - (IFS-30821) if the operation fails
  (Published)

### removeAttribute

    public void removeAttribute(Attribute attribute,
                                AttributeDefinition def)
                         throws IfsException

  Description copied from class: `ClassObject`
  Removes an attribute from this ClassObject.

  Parameters:
    `attribute` - the attribute to remove
    `def` - a definition that influences how the attribute is removed, or null for default behavior
  Throws:
    `IfsException` - (IFS-30821) if the operation fails
  (Unpublished)

### getEffectiveClassAttributes

    public Attribute[] getEffectiveClassAttributes()
                                            throws IfsException

  Description copied from class: `ClassObject`
  Gets the effective Attributes of this ClassObject.

  The effective Attributes of a ClassObject are both the Attributes introduced by the ClassObject itself as well as the Attributes the ClassObject inherits from its superclasses.

  Returns:
    the Attributes
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getEffectiveClassAttributes

    public Attribute getEffectiveClassAttributes(int index)
                                          throws IfsException

  Description copied from class: `ClassObject`
  Gets the specified effective Attribute of this ClassObject.

  The effective Attributes of a ClassObject are both the Attributes introduced by the ClassObject itself as well as the Attributes the ClassObject inherits from its superclasses.

  Parameters:
    `index` - the zero-based index
  Returns:
    the Attribute
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getEffectiveClassAttributes

    public Attribute getEffectiveClassAttributes(java.lang.String attributeName)
                                          throws IfsException

  Description copied from class: `ClassObject`
  Gets the specified effective Attribute of this ClassObject.

  The effective Attributes of a ClassObject are both the Attributes introduced by the ClassObject itself as well as the Attributes the ClassObject inherits from its superclasses.

  Parameters:
    `attributeName` - the Attribute name
  Returns:
    the Attribute, or null if there is no Attribute with the specified name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getEffectiveClassAttributeIndex

    public int getEffectiveClassAttributeIndex(java.lang.String attributeName)
                                        throws IfsException

  Description copied from class: `ClassObject`
  Gets the index of the specified effective Attribute of this ClassObject.

  The effective Attributes of a ClassObject are both the Attributes introduced by the ClassObject itself as well as the Attributes the ClassObject inherits from its superclasses.

  Parameters:
    `attributeName` - the Attribute name
  Returns:
    the index
  Throws:
    `IfsException` - (IFS-10407) if the Attribute name is not the name of an effective Attribute of this ClassObject
    `IfsException` - if the operation otherwise fails
  (Unpublished)

### getExtendedClassAttributes

    public Attribute[] getExtendedClassAttributes()
                                           throws IfsException

  Description copied from class: `ClassObject`
  Gets the extended Attributes of this ClassObject.

  The extended Attributes of a ClassObject are only the Attributes introduced by the ClassObject itself, and do not include any Attributes the ClassObject inherits from its superclasses.

  Returns:
    the Attributes. If the class has no extended Attributes, an zero-length array is returned.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getExtendedClassAttributes

    public Attribute[] getExtendedClassAttributes(ClassObject superclass)
                                           throws IfsException

  Description copied from class: `ClassObject`
  Gets an array of the Attributes that this ClassObject has and that the specified superclass does not have.

  Parameters:
    `superclass` - a superclass of this ClassObject
  Returns:
    the Attributes. If this ClassObject has exactly the same Attributes as the specified superclass, a zero-length array is returned.
  Throws:
    `IfsException` - (IFS-19001) if `superclass` is null
    `IfsException` - (IFS-19005) if `superclass` is not a superclass of this ClassObject
    `IfsException` - if the operation otherwise fails
  (Published)

### getExtendedClassAttributes

    public Attribute getExtendedClassAttributes(int index)
                                         throws IfsException

  Description copied from class: `ClassObject`
  Gets the specified extended Attribute of this ClassObject.

  The extended Attributes of a ClassObject are only the Attributes introduced by the ClassObject itself, and do not include any Attributes the ClassObject inherits from its superclasses.

  Parameters:
    `index` - the zero-based index
  Returns:
    the Attribute
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getExtendedClassAttributes

    public Attribute getExtendedClassAttributes(java.lang.String attributeName)
                                         throws IfsException

  Description copied from class: `ClassObject`
  Gets the specified extended Attribute of this ClassObject.

  The extended Attributes of a ClassObject are only the Attributes introduced by the ClassObject itself, and do not include any Attributes the ClassObject inherits from its superclasses.

  Parameters:
    `attributeName` - the Attribute name
  Returns:
    the Attribute, or null if there is no Attribute with the specified name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getExtendedClassAttributeIndex

    public int getExtendedClassAttributeIndex(java.lang.String attributeName)
                                       throws IfsException

  Description copied from class: `ClassObject`
  Gets the index of the specified extended Attribute of this ClassObject.

  The extended Attributes of a ClassObject are only the Attributes introduced by the ClassObject itself, and do not include any Attributes the ClassObject inherits from its superclasses.

  Parameters:
    `attributeName` - the Attribute name
  Returns:
    the index
  Throws:
    `IfsException` - (IFS-10407) if the Attribute name is not the name of an extended Attribute of this ClassObject
    `IfsException` - if the operation otherwise fails
  (Unpublished)

### isAttribute

    public boolean isAttribute(java.lang.String attrName)
                        throws IfsException

  Description copied from class: `ClassObject`
  Gets whether this ClassObject has an Attribute with the specified name.

  Parameters:
    `attrName` - the Attribute name
  Returns:
    whether this ClassObject has an Attribute with that name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSuperclass

    public ClassObject getSuperclass()
                              throws IfsException

  Description copied from class: `ClassObject`
  Gets the superclass of this ClassObject.

  Returns:
    the superclass, or null if this ClassObject has no superclass
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getDirectSubclasses

    public ClassObject[] getDirectSubclasses()
                                      throws IfsException

  Description copied from class: `ClassObject`
  Gets the direct subclasses of this ClassObject.

  The direct subclasses are the ClassObjects that directly extend this ClassObject.

  Returns:
    the subclasses
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getDirectSubclasses

    public ClassObject getDirectSubclasses(int index)
                                    throws IfsException

  Description copied from class: `ClassObject`
  Gets the specified direct subclass of this ClassObject.

  The direct subclasses are the ClassObjects that directly extend this ClassObject.

  Parameters:
    `index` - the zero-based index
  Returns:
    the subclass
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSubclasses

    public ClassObject[] getSubclasses()
                                throws IfsException

  Description copied from class: `ClassObject`
  Gets the subclasses of this ClassObject.

  The subclasses are the ClassObjects that directly extend this ClassObject and their subclasses, sub-subclasses, etc.

  Returns:
    the subclasses
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSubclasses

    public ClassObject getSubclasses(int index)
                              throws IfsException

  Description copied from class: `ClassObject`
  Gets the specified subclass of this ClassObject.

  The subclasses are the ClassObjects that directly extend this ClassObject and their subclasses, sub-subclasses, etc.

  Parameters:
    `index` - the zero-based index
  Returns:
    the subclass
  Throws:
    `IfsException` - if the operation fails
  (Published)

### isDirectSubclassOf

    public boolean isDirectSubclassOf(ClassObject classObject)
                               throws IfsException

  Description copied from class: `ClassObject`
  Gets whether this ClassObject is a direct subclass of the specified ClassObject.

  Parameters:
    `classObject` - the ClassObject to test
  Returns:
    whether this ClassObject is a direct subclass of `classObject`
  Throws:
    `IfsException` - (IFS-19001) if `classObject` is null
  (Published)

### isSubclassOf

    public boolean isSubclassOf(ClassObject classObject)
                         throws IfsException

  Description copied from class: `ClassObject`
  Gets whether this ClassObject is a subclass of the specified ClassObject.

  Parameters:
    `classObject` - the ClassObject to test
  Returns:
    whether this ClassObject is a subclass of `classObject`
  Throws:
    `IfsException` - (IFS-19001) if `classObject` is null
  (Published)

### isVersionable

    public boolean isVersionable()
                          throws IfsException

  Description copied from class: `ClassObject`
  Gets whether instances of this ClassObject are versionable.

  Returns:
    whether instances of this ClassObject are versionable
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getInheritedPropertyValue

    public AttributeValue getInheritedPropertyValue(java.lang.String name)
                                             throws IfsException

  Description copied from class: `ClassObject`
  gets named property, if any, by searching in the target ClassObject's PropertyBundle, or in one of its superclasses PropertyBundle. Return null if no property exists for this name.

  Parameters:
    `name` - Property name
  Returns:
    the AttributeValue for the requested property, or null if no specific Proeprty exists on this class or superclasses.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getLibraryObjectLookupCache

    public static LibraryObjectLookupCache getLibraryObjectLookupCache(LibrarySessionInterface session)
                                                                throws IfsException

  Description copied from class: `ClassObject`
  Returns the LibraryObjectLookupCache used by find ClassObject instances by name.

  Parameters:
    `session` - the session context
  Returns:
    the LibraryObjectLookupCache
  Throws:
    `IfsException` - if the operation fails.

### findAll

    public static ClassObject[] findAll(LibrarySession session)
                                 throws IfsException

  Description copied from class: `ClassObject`
  Returns the set of defined ClassObjects.

  The instances will be sorted by name.

  Parameters:
    `session` - the session context
  Returns:
    the set of ClassObjects; returns null if there are none
  Throws:
    `IfsException` - if the operation fails.

### findByName

    public static ClassObject findByName(LibrarySession session,
                                         java.lang.String name)
                                  throws IfsException

  Description copied from class: `ClassObject`
  Returns the a ClassObject matching the specified name.

  ClassObject name lookups are case insensitive, so this operation ignores case.

  Parameters:
    `session` - the session context
    `name` - the ClassObject name
  Returns:
    the ClassObject matching the specified name; or null if there exists no matching ClassObject
  Throws:
    `IfsException` - if the operation fails.

### constructClassObjectVector

    protected static java.util.Vector constructClassObjectVector(LibrarySession sess,
                                                                 java.util.Vector vector)
                                                          throws IfsException

  Description copied from class: `ClassObject`
  Internal use only: Converts a vector of S_LibraryObjectDatas to a vector of ClassObjects.

  For internal use only. Do not use this method.

  Parameters:
    `sess` - the session
    `vector` - the S_LibraryObjectData vector
  Returns:
    the ClassObject vector
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### constructClassObject

    protected static ClassObject constructClassObject(LibrarySession sess,
                                                      S_LibraryObjectData data)
                                               throws IfsException

  Description copied from class: `ClassObject`
  Internal use only: Constructs a ClassObject for the specified data.

  For internal use only. Do not use this method.

  Parameters:
    `sess` - the session
    `data` - the data
  Returns:
    the ClassObject
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### vectorToClassObjectArray

    public static ClassObject[] vectorToClassObjectArray(java.util.Vector vector)

  Description copied from class: `ClassObject`
  Internal use only: Converts a vector of ClassObjects to an a ClassObject array.

  For internal use only. Do not use this method.

  Parameters:
    `vector` - the vector
  Returns:
    the array
  (Unpublished)

### vectorClassObjectElement

    protected static ClassObject vectorClassObjectElement(java.util.Vector vector,
                                                          int index)

  Description copied from class: `ClassObject`
  Internal use only: Gets the specified element of a vector of ClassObjects.

  For internal use only. Do not use this method.

  Parameters:
    `vector` - the vector
    `index` - the zero-based index
  Returns:
    the ClassObject
  (Unpublished)

### getBeansConstructor

    public java.lang.reflect.Constructor getBeansConstructor()
                                                      throws IfsException

  Description copied from class: `ClassObject`
  Internal use only: Gets the four-argument constructor for the Java class returned by `getBeansClasspath`.

  For internal use only. Do not use this method.

  Returns:
    the constructor
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getDescription

    public java.lang.String getDescription()
                                    throws IfsException

  Description copied from class: `ClassObject`
  Returns the description of a Class Object.

  Returns:
    The description of the ClassObject.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getServerClasspath

    public java.lang.String getServerClasspath()
                                        throws IfsException

  Description copied from class: `ClassObject`
  Returns the ServerClassPath Attribute of the Library Object.

  Returns:
    The Server Class Path.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setServerClasspath

    public void setServerClasspath(java.lang.String path)
                            throws IfsException

  Description copied from class: `ClassObject`
  Sets the Server Class Path attribute.

  Parameters:
    `path` - The server class path
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### getSelectorClasspath

    public java.lang.String getSelectorClasspath()
                                          throws IfsException

  Description copied from class: `ClassObject`
  Returns the SelectorClassPath Attribute of the Library Object.

  Returns:
    The Selector Class Path.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setSelectorClasspath

    public void setSelectorClasspath(java.lang.String path)
                              throws IfsException

  Description copied from class: `ClassObject`
  Sets the Selector Class Path attribute.

  Parameters:
    `path` - The selector class path
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### getDatabaseObjectName

    public java.lang.String getDatabaseObjectName()
                                           throws IfsException

  Description copied from class: `ClassObject`
  Returns the Database Object Name.

  Returns:
    The Database Object Name.
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### isAbstract

    public boolean isAbstract()
                       throws IfsException

  Description copied from class: `ClassObject`
  Determines if this is an abstract object.

  Returns:
    true if the object is abstract.
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### isFinal

    public boolean isFinal()
                    throws IfsException

  Description copied from class: `ClassObject`
  Determines if this is object cannot be sub-classed.

  Returns:
    true if the object is final.
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### isPartitioned

    public boolean isPartitioned()
                          throws IfsException

  Description copied from class: `ClassObject`
  Determines if this is a partitioned object.

  Returns:
    true if the object is partitioned.
  Throws:
    `IfsException` - if the operation fails.
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD